const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_blocks = sequelize.define(
    'inventory_blocks',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

start_at: {
        type: DataTypes.DATE,
      
      

      },

end_at: {
        type: DataTypes.DATE,
      
      

      },

block_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"maintenance",


"owner_use",


"group_hold",


"overbooking_protection"

        ],

      },

rooms_blocked: {
        type: DataTypes.INTEGER,
      
      

      },

reason: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_blocks.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.inventory_blocks.belongsTo(db.room_types, {
      as: 'room_type',
      foreignKey: {
        name: 'room_typeId',
      },
      constraints: false,
    });




    db.inventory_blocks.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_blocks.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_blocks;
};


